from urllib.request import urlopen
import json

# get and parse json data
def get_jsonparsed_data(url):
    response = urlopen(url)
    str_response = response.read().decode('utf-8')
    return json.loads(str_response)

# count user in Two_Million_LastFM_User_Profiles.csv
a = 0

# url for json request
basic_url = "http://ws.audioscrobbler.com/2.0/?"
method = "method=user.gettoptracks"
user = "jakedahn"
period = "&period=12month"
limit = "&limit=200"
page = "&page=1"
api_key = "&api_key=4a9f5581a9cdf20a699f540ac52a95c9"
json_format = "&format=json"
# url = basic_url + method + "&user=" + user + period + limit + page + api_key + json_format

# file address and file names
file_address = "D:/F/UnivSub/UNC/masterpaper/data/last.fm/"
file_nameR = "Two_Million_LastFM_User_Profiles.csv"
file_nameW = "toptrackALL.json"

# variables
toptrackALL = []
usernum = 0
male = 0
female = 0

# read username in Two_Million_LastFM_User_Profiles.csv
file_readuser = open(file_address + file_nameR, 'r')

# each user
for line in file_readuser:

    # first line is metadata
    if a == 0:
        a += 1
    else:
        a += 1
        # get 100 sample users
        if usernum < 10000:
            line = line.strip('\n')
            line_value = line.split(',')

            # get user metadata
            username = line_value[1]
            country = line_value[14]
            age = line_value[15]
            gender = line_value[16]

            user = username
            url = basic_url + method + "&user=" + user + period + limit + page + api_key + json_format
            j = get_jsonparsed_data(url)

            # check if request valid
            track_exist = 'toptracks'
            if track_exist in j:
                totaltrack = j['toptracks']['@attr']['total']
                totaltrack = int(totaltrack)
            else:
                continue

            # check if at least 200 top tracks records in the period of recent 12 month.
            if totaltrack >= 200:
                toptrack = j['toptracks']['track']
                userdict = {}
                userdict['username'] = username
                userdict['country'] = country
                userdict['age'] = age
                userdict['gender'] = gender
                userdict['totaltrack'] = totaltrack
                userdict['top200'] = []

                # save top 200 tracks
                for i in range(0, 200):
                    track = {}
                    track['rank'] = toptrack[i]['@attr']['rank']
                    track['name'] = toptrack[i]['name']
                    track['artist'] = toptrack[i]['artist']['name']
                    track['playcount'] = toptrack[i]['playcount']

                    userdict['top200'].append(track)

                # count number of male users and female users in the sample
                if gender == 'm':
                    male += 1
                elif gender == 'f':
                    female += 1
                else:
                    pass

                # save user top 200 track in toptrackALL dictionary
                toptrackALL.append(userdict)

                usernum += 1
                print('Top 200 tracks of', usernum, 'users have been extracted.')
                print(male)
                print(female)
                print('Two_Million_LastFM_User_Profiles.csv:', a)
            else:
                continue

        else:
            break

file_readuser.close()

# output result
with open(file_address + file_nameW, 'w') as f:
    json.dump(toptrackALL, f, sort_keys=True, indent=2)

print('10000 users sample success')





