from urllib.request import urlopen
from urllib.parse import quote
import pygn
import json

# get and parse json data
def get_jsonparsed_data(url):
    response = urlopen(url)
    str_response = response.read().decode('utf-8')
    return json.loads(str_response)

tracknum = 1
indexnum = 1
noyear = 0

# url for json request
basic_url = "http://ws.audioscrobbler.com/2.0/?"
method = "method=track.getInfo"
method_tag = "method=track.gettoptags"
artistValue = "Petit biscuit"
trackValue = "Sunset Lover"
api_key = "&api_key=4a9f5581a9cdf20a699f540ac52a95c9"
json_format = "&format=json"
# url = basic_url + method + "&artist=" + artistValue + "&track=" + trackValue + api_key + json_format
# lastfm_info = get_jsonparsed_data(url)

# for gn data
clientID = '456323715-074A0BB4AC7C015D461D95180423EFEF' # Enter your Client ID here
userID = pygn.register(clientID)

# file address and file names
file_address = "D:/F/UnivSub/UNC/masterpaper/data/last.fm/"
file_nameR = "toptrackfilter100.json"
file_nameW = "toptrackfilter100info.json"

fp = open(file_address + file_nameR, "r")
s = fp.read()
j = json.loads(s)

toptracklist = [] + j
toptrackfilter = []

# each track
for track in toptracklist:
    # print(track['id'])
    if track['occurcount'] > 100:
        artistValue = track['artist']
        trackValue = track['name']
        url = basic_url + method + "&artist=" + quote(artistValue) + "&track=" + quote(trackValue) + api_key + json_format
        url_tag = basic_url + method_tag + "&artist=" + quote(artistValue) + "&track=" + quote(
            trackValue) + api_key + json_format
        lastfm_info = get_jsonparsed_data(url)
        lastfm_info_tag = get_jsonparsed_data(url_tag)

        gn_info = pygn.search(clientID=clientID, userID=userID, artist=artistValue, track=trackValue)

        # check if request valid
        lastfm_exist = 'track'
        lastfm_tag_exist = 'toptags'
        gn_exist = 'album_title'
        if lastfm_exist in lastfm_info:
            if lastfm_tag_exist in lastfm_info_tag:
                if gn_exist in gn_info:
                    a = gn_info['album_artist_name'].lower()
                    b = artistValue.lower()
                    c = gn_info['track_title'].lower()
                    d = trackValue.lower()
                    if a == b:
                        if c == d:
                            newtrack = dict(track)
                            # newtrack = {}
                            listeners = lastfm_info['track']['listeners']
                            listeners = int(listeners)
                            newtrack['listeners'] = listeners
                            playcount = lastfm_info['track']['playcount']
                            playcount = int(playcount)
                            newtrack['playcount'] = playcount
                            toptags = []
                            for tag in lastfm_info_tag['toptags']['tag']:
                                toptags.append(tag['name'])
                            newtrack['toptags'] = toptags
                            album_title = gn_info['album_title']
                            newtrack['album_title'] = album_title
                            album_year = gn_info['album_year']
                            if album_year:
                                album_year = int(album_year)
                            else:
                                album_year = 0
                                noyear += 1
                                print('No year: ', noyear)
                            newtrack['album_year'] = album_year
                            artist_era = []
                            for era in gn_info['artist_era']:
                                artist_era.append(gn_info['artist_era'][era]['TEXT'])
                            newtrack['artist_era'] = artist_era
                            artist_origin = []
                            for origin in gn_info['artist_origin']:
                                artist_origin.append(gn_info['artist_origin'][origin]['TEXT'])
                            newtrack['artist_origin'] = artist_origin
                            artist_type = []
                            for atype in gn_info['artist_type']:
                                artist_type.append(gn_info['artist_type'][atype]['TEXT'])
                            newtrack['artist_type'] = artist_type
                            genre = []
                            for g in gn_info['genre']:
                                genre.append(gn_info['genre'][g]['TEXT'])
                            newtrack['genre'] = genre
                            mood = []
                            for m in gn_info['tracks'][0]['mood']:
                                mood.append(gn_info['tracks'][0]['mood'][m]['TEXT'])
                            newtrack['mood'] = mood
                            tempo = []
                            for t in gn_info['tracks'][0]['tempo']:
                                tempo.append(gn_info['tracks'][0]['tempo'][t]['TEXT'])
                            newtrack['tempo'] = tempo
                            toptrackfilter.append(newtrack)
                            print('track id: ', track['id'])
                            print('num: ', tracknum)
                            print('index: ', indexnum)
                            tracknum += 1

    else:
        pass
    indexnum += 1

with open(file_address + file_nameW, 'w') as f:
    json.dump(toptrackfilter, f, sort_keys=True, indent=2)

print('No year: ', noyear)
print('top tracks filter success')